import { IRequestSender, ISuperAgentRequestFactory } from '@studyportals/mb-platform-http-requests';
import { IOrganisationCard } from '@studyportals/domain-client';
import { IGetOrganisationCardsReponse, IGetOrganisationsReponse, IRankingOrganisationSearchFilters } from './interfaces';
export declare class RankingApiClient {
    private readonly apiUriBase;
    private readonly requestFactory;
    private readonly requestSender;
    private readonly organisationCardFactory;
    constructor(apiUriBase: string, requestFactory: ISuperAgentRequestFactory, requestSender: IRequestSender);
    getOrganisationCards(filters: IRankingOrganisationSearchFilters, limit: number, offset: number): Promise<IGetOrganisationCardsReponse<IOrganisationCard>>;
    getOrganisations(filters: IRankingOrganisationSearchFilters, limit: number, offset: number): Promise<IGetOrganisationsReponse>;
    private constructUri;
}
